package com.nisum.products_producer.service;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.nisum.products_producer.model.Product;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.mockito.*;
import org.springframework.kafka.core.reactive.ReactiveKafkaProducerTemplate;
import reactor.core.publisher.Mono;
import reactor.kafka.sender.SenderResult;
import reactor.test.StepVerifier;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.mockito.Mockito.*;

public class KafkaProducerServiceTest {

    @Mock
    private ReactiveKafkaProducerTemplate<String, String> kafkaProducerTemplate;

    @Mock
    private ObjectMapper objectMapper;

    @InjectMocks
    private KafkaProducerService kafkaProducerService;

    @Captor
    private ArgumentCaptor<ProducerRecord<String, String>> producerRecordCaptor;

    private Product mockProduct;

    @BeforeEach
    void setUp() {
        MockitoAnnotations.openMocks(this);
        kafkaProducerService = new KafkaProducerService(kafkaProducerTemplate, objectMapper);

        // Simulate property injection (normally injected by Spring)
        java.lang.reflect.Field topicField;
        try {
            topicField = KafkaProducerService.class.getDeclaredField("topic");
            topicField.setAccessible(true);
            topicField.set(kafkaProducerService, "product_topic");
        } catch (Exception e) {
            throw new RuntimeException(e);
        }

        mockProduct = Product.builder()
                .id("p123")
                .name("TestProduct")
                .price(99.99)
                .build();
    }




}
